#include <stdio.h>
#include "data_structure.h"
#include "readinput.h"
#include "record_handler.h"

void print_account_record_list(const struct account_record_list list);
struct person_consumption_list handler_account_record_list(
		const struct account_record_list list);
int main()
{
	struct account_record_list list ;
	list = read_input();
	print_account_record_list(list);
	struct person_consumption_list consumption_list = 
		handler_account_record_list(list);
	print_person_consumption_list(consumption_list);
	return 0;
	
}
void print_account_record_list(const struct account_record_list list)
{  
	int i = 0,j=0;
	for(i = 0; i < list.count; i++)
	{
		struct account_record record = list.records[i];
		printf("%s\n",record.date);
		printf("\tdiscount=%0.2f\n",record.discount);
		printf("\tconsumption=%d\n",record.total_consumption);
		printf("\tperson:\n\t\t");
		for(j=0; j < record.people_count; j++){
			printf("%s,",record.person[j].name);	
		}
		printf("\n\tpay_record\n");
		for(j = 0; j < record.pay_record_count; j++)
		{
			printf("\t\t%s:%0.2f\n",
					record.payrecord[j].person.name,
					record.payrecord[j].amount);
		}
		printf("\n");
	}
}
struct person_consumption_list handler_account_record_list(
		const struct account_record_list list)
{
	struct person_consumption_list consumption_list;
	consumption_list.count = 0;
	int i = 0, j = 0;
	for(i = 0; i < list.count; i++)
	{
		struct account_record record = list.records[i];
		double average_consumption =
			calc_avg_consumption(
					record.total_consumption,
					record.people_count,
					record.discount);
		for(j = 0; j < record.people_count; j++)
		{
			edit_person_consumption(&consumption_list,
					record.person[j].name,
					-average_consumption);
			int k =0;
		}
		for(j = 0; j< record.pay_record_count; j++)
		{
			edit_person_consumption(&consumption_list,
					record.payrecord[j].person.name,
					record.payrecord[j].amount);
		}
	}
	return consumption_list;
}

