#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "data_structure.h"

void set_date(struct account_record *record, const char *buff);
void set_discount(struct account_record *record, const char *buff);
void set_person(struct account_record *record, const char *buff);
void set_payrecord(struct account_record *record, const char *buff);
void set_consumption(struct account_record *record, const char *buff);

struct account_record_list read_input()
{
	FILE *fp;
	if((fp=fopen("input.txt","rt")) == NULL)
	{
		printf("cannot open input.txt");
		getchar();
		exit(1);
	}

	int i = 0;
	enum read_state {
		state_default,
		state_date,
		state_consumption,
		state_discount,
		state_person,
		state_payrecord
	} state;
	state = state_date;
	struct account_record_list result;
	result.count = 0;
	struct account_record *p_record = result.records;
	char temp_buffer[512];
	memset(temp_buffer, 0, 512);
	char *p_temp_buffer = temp_buffer;
	char ch = fgetc(fp);
	while (ch != EOF)
	{
		if(result.count > MAX_RECORD_COUNT)
		{
			printf("max record count");
			break;
		}
		if(ch != '|' && ch != '\n'){
			*(p_temp_buffer++) = ch;
		}
		else{
			*(p_temp_buffer++) = '\0';
			switch(state)
			{
				case state_date:
				        set_date(p_record,temp_buffer);
					state = state_consumption;
					break;
				case state_consumption:
					set_consumption(p_record,temp_buffer);
					state = state_discount;
					break;
				case state_discount:
					set_discount(p_record,temp_buffer);
					state = state_person;
					break;
				case state_person:
					set_person(p_record,temp_buffer);
					state = state_payrecord;
					break;
				case state_payrecord:
					set_payrecord(p_record,temp_buffer);
					state = state_default;
					break;
			
				default:
					printf("state is error");
					break;
			}
			memset(temp_buffer, 0, 512);
			p_temp_buffer = temp_buffer;

		}

		if(ch == '\n'){
			result.count++;
			p_record++;
			memset(temp_buffer, 0, 512);
			p_temp_buffer = temp_buffer;
			state = state_date;
		}
		putchar(ch);
		ch = fgetc(fp);
	}
	fclose(fp);
	return result;
}
void set_date(struct account_record *record, const char *buff){
	memset(record -> date,0, MAX_ARRAY_COUNT);
	strncpy(record -> date,buff,MAX_ARRAY_COUNT*sizeof(char)); 
}
void set_discount(struct account_record *record, const char *buff){
	record -> discount = atof(buff);
}
void set_person(struct account_record *record, const char *buff){
	char temp_buffer[512];
	strncpy(temp_buffer,buff,512*sizeof(char));
	char *p = strtok(temp_buffer,",");
	struct people *p_people = record -> person;
	while(p != NULL){
		record -> people_count ++;
		strncpy((*(p_people++)).name,p,MAX_ARRAY_COUNT*sizeof(char));
		p = strtok(NULL, ",");	
	}
}
void set_payrecord(struct account_record *record, const char *buff){
	char temp_buffer[512];
	memset(temp_buffer, 0, 512);
	strncpy(temp_buffer, buff, 512*sizeof(char));
	
	char c[MAX_ARRAY_COUNT][2*MAX_ARRAY_COUNT] = {{'\0'}};
	char (*pc)[2*MAX_ARRAY_COUNT] = c;

	char *p = strtok(temp_buffer,",");
	int paycount= 0;
	while(p != NULL)
	{
		strncpy(*pc++, p, 2*MAX_ARRAY_COUNT*sizeof(char));
		p = strtok(NULL,",");
		paycount++;
	}

	struct pay_record *payrecord = record -> payrecord;
	int i = 0;
	for(i = 0; i < paycount; i++)
	{
		char *p2 = strtok(c[i],":");
		if(p2 == NULL)
		{
			printf("error:parse payrecord error");
			return;
		}
		struct people person;
		strncpy(person.name, p2, MAX_ARRAY_COUNT*sizeof(char));
		p2 = strtok(NULL,":");
		if(p2 == NULL)
		{
			printf("error:parse payrecord error");
			return;
		}
		double amount = atof(p2);
		
		payrecord -> person = person;
		payrecord -> amount = amount;
		payrecord++;
		record -> pay_record_count++;
	}
}
void set_consumption(struct account_record *record, const char *buff){
	record -> total_consumption = atoi(buff);
}

